<!doctype html>
<html lang="de">
<head>
  <?php include 'title.php'; ?>
  <meta charset="utf-8">
  <meta http-equiv="refresh" content="60">
  <meta name="author" content="Scott Falk Hühn">
  <meta name="editor" content="GNU nano 2.7.4">
  <meta name="robots" content="noindex">
  <meta name="date" content="2018-06-04">
  <link rel="shortcut icon" href="favicon.ico">
  <link rel="apple-touch-icon" href="icon.png">
  <link rel="apple-touch-icon-precomposed" href="icon.png">
  <link rel="stylesheet" href="style.css" type="text/css">
</head>
<body>
  <?php
    include 'menu.php';                                                     // Menü einbinden
    echo "<br>\n";                                                          // Zwischenraum
    $logdir = "/srv/sensor";                                                // Verzeichnis für Log-Daten
    $cfgdir = "/srv/sensor";                                                // Verzeichnis für Konfig-Daten
    if (file_exists($logdir . "/alog")) {                                   // wenn Alarm-Log vorhanden
      $alog = fopen($logdir . "/alog", "r");                                // Alarm-Log öffnen
      echo '<table class="t2">';                                            // Tabellen-Parameter ausgeben
      echo "<tr><th>Datum</th><th>Zeit</th><th>Alarm</th><th>Status</th></tr>\n"; // Tabellenkopf ausgeben
      while(!feof($alog)) {                                                 // Schleife bis Dateiende
        $aline = rtrim(fgets($alog, 100));                                  // Alarmmeldung lesen
        if (strlen($aline) == 22) {                                         // wenn Zeilenlänge = 22
          echo '<tr><td>', substr($aline, 0, 10), '</td>';                  // Datum ausgeben
          echo '<td>', substr($aline, 11, 8), '</td>';                      // Zeit ausgeben
          $anum = substr($aline, 20, 1);                                    // Alarmnummer lesen
          if ($anum > 0 and $anum < 5) {                                    // wenn gültige Alarmnummer
            if (file_exists($cfgdir . "/al" . $anum)) {                     // wenn Konfigurationsdatei vorhanden
              $afile = fopen($cfgdir . "/al" . $anum, "r");                 // Konfigurationsdatei öffnen
              $aname = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8"); // Alarmname lesen
              $aidle = rtrim(fgets($afile, 10));                                    // Alarm-Ruhezustand lesen
              $adeac = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8"); // Normalstatustext holen
              $aactv = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8"); // Alarmstatustext holen
              fclose($afile);                                               // Konfigurationsdatei schließen
            }
            else {                                                          // wenn Konfigurationsdatei nicht vorhanden
              $aname = 'Fehler';                                            // Fehlertexte setzen
              $aidle = 0;
              $adeac = 'Fehler';
              $aactv = 'Fehler';
            }
            echo '<td>', $aname, '</td>';                                   // Alarmname ausgeben
            if (substr($aline,21,1) == $aidle) {                            // wenn Ruhezustand
              echo '<td><span class="al0">', $adeac;                        // Normalstatustext ausgeben
            }
            else {                                                          // wenn Alarmzustand
              echo '<td><span class="al1">', $aactv;                        // Alarmstatustext ausgeben
            }
          }
          else {                                                            // wenn ungültige Alarmnummer
            echo '<td colspan="2"><span class="al1">Fehler';                // Fehlertext ausgeben
          }
          echo "</span></td></tr>\n";                                       // Zeilenende ausgeben
        }
      }
      fclose($alog);
      echo "</table>";                                                      // Tabellenende
    }
    else { echo "Keine Daten vorhanden!\n"; }                               // Meldung bei leerem Alarm-Log
  ?>
</body>
</html>
