<!doctype html>
<html lang="de">
<head>
  <?php include 'title.php'; ?>
  <meta charset="utf-8">
  <meta name="author" content="Scott Falk Hühn">
  <meta name="editor" content="GNU nano 3.2">
  <meta name="robots" content="noindex">
  <meta name="date" content="2019-12-30">
  <link rel="shortcut icon" href="favicon.ico">
  <link rel="apple-touch-icon" href="icon.png">
  <link rel="apple-touch-icon-precomposed" href="icon.png">
  <link rel="stylesheet" href="style.css" type="text/css">
</head>
<body>
  <?php
    include 'menu.php';                                   // Menü einbinden
    $cfgdir  = '/srv/sensor';                             // Verzeichnis für Konfig-Daten
    $wwwname = 'sensor.dat';                              // Name der Anzeige-Konfigurationsdatei
    $sername = 'server.dat';                              // Name der Servernamendatei

    $wwwok = 0;                                           // Flag für Bestätigung löschen
    if (isset($_POST['cfgwww'])) {                        // wenn neue Anzeige-Konfiguration gesendet
      $senfile = fopen($wwwname, "w");                    // neue Sensoranzeigedatei erstellen
      $pict = $_POST['bgpic'];                            // Name für Hintergrundbild holen
      fwrite($senfile, "$pict\n");                        // und speichern
      $end = $_POST['end'];                               // Versteckten Wert holen, enthält Anzahl der Zeilen + 1
      for ($i = 1; $i < $end; $i++) {                     // Schleife zum Lesen der Datenzeilen
        $ftyp = $_POST['ftyp' . $i];                      // Feldtyp holen
        $xdir = $_POST['xdir' . $i];                      // X-Richtung holen
        $xpos = $_POST['xpos' . $i];                      // X-Abstand holen
        $ydir = $_POST['ydir' . $i];                      // Y-Richtung holen
        $ypos = $_POST['ypos' . $i];                      // Y-Abstand holen
        if ($ftyp > 0) {                                  // wenn gültiger Feldtyp
          if ($xpos > '' && $ypos > '') {                 // wenn Abstandswerte vorhanden
            fwrite($senfile, $ftyp . ',' . $xdir . $xpos . ',' . $ydir . $ypos); // in Sensoranzeigedatei schreiben
            for ($j = 1; $j < 7; $j++) {                  // Schleife für 6 Datenfelder
              $etyp = $_POST['dat' . $i . '-' . $j];      // Element-Typ holen
              $j++;                                       // nächstes Datenfeld
              $epar = $_POST['dat' . $i . '-' . $j];      // Element-Parameter holen
              if ($etyp != 'no') {                        // wenn gültiger Element-Typ
                fwrite($senfile, ',' . $etyp . $epar);    // in Sensoranzeigedatei schreiben
              }
            }
            fwrite($senfile, "\n");                       // Zeile in Sensoranzeigedatei abschließen
          }
        }
      }
      fclose($senfile);                                   // Sensoranzeigedatei schließen
      chmod($wwwname, 0664);                              // Rechte anpassen (pi darf schreiben)
      $wwwok = 1;                                         // Flag für Bestätigung setzen
    }

    $senok = 0;                                           // Flag für Bestätigung löschen
    if (isset($_POST['cfgsen'])) {                        // wenn neue Sensor-Grundkonfiguration gesendet
      for ($i = 1; $i < 32; $i++) {                       // 31 Sensordateien bearbeiten
        $sfile = fopen($cfgdir . '/s' . $i, "w");         // neue Sensordatei erstellen
        $sname = html_entity_decode($_POST['sen' . $i], ENT_HTML5, "UTF-8"); // Sensorname holen
        $smin = $_POST['min' . $i];                       // Minimalwert holen
        $smax = $_POST['max' . $i];                       // Maximalwert holen
        $slock = 0;                                       // Sperre zunächst ausschalten
        if (isset($_POST['lck' . $i])) {                  // wenn Sperre gesetzt
          $slock = $_POST['lck' . $i];                    // Wert holen
        }
        $stop = html_entity_decode($_POST['top' . $i], ENT_HTML5, "UTF-8");
        fwrite($sfile, $sname . "\n");                    // Sensorname schreiben
        fwrite($sfile, $smin . "\n");                     // Minimalwert speichern
        fwrite($sfile, $smax . "\n");                     // Maximalwert speichern
        fwrite($sfile, $slock . "\n");                    // Sperre speichern
        fwrite($sfile, $stop . "\n");                     // Topic speichern
        fclose($sfile);                                   // Sensordatei schließen
        chmod($cfgdir . '/s' . $i, 0664);                 // Rechte anpassen (pi darf schreiben)
      }
      $height = $_POST['height'];                         // Höhenwert holen
      $sfile = fopen($cfgdir . '/height', "w");           // neue Höhendatei erstellen
      fwrite($sfile, $height . "\n");                     // Höhenweert speichern
      fclose($sfile);                                     // Höhendatei schließen
      chmod($cfgdir . '/height', 0664);                   // Rechte anpassen (pi darf schreiben)
      $sfile = fopen($cfgdir . '/change', "w");           // neue Change-Datei erstellen
      fclose($sfile);                                     // und wieder schließen (hat dann 0 Bytes)
      $senok = 1;                                         // Flag für Bestätigung setzen
    }

    $alok = 0;                                            // Flag für Bestätigung löschen
    if (isset($_POST['cfgalm'])) {                        // wenn neue Alarm-Grundkonfiguration gesendet
      for ($i = 1; $i < 5; $i++) {                        // 4 Alarmdateien bearbeiten
        $afile = fopen($cfgdir . '/al' . $i, "w");        // neue Alarmdatei erstellen
        $aname = html_entity_decode($_POST['aln' . $i], ENT_HTML5, "UTF-8"); // Alarmname holen
        $aidle = $_POST['aid' . $i];                                         // Ruhezustand holen
        $adeac = html_entity_decode($_POST['ade' . $i], ENT_HTML5, "UTF-8"); // Normalzustand holen
        $aactv = html_entity_decode($_POST['aac' . $i], ENT_HTML5, "UTF-8"); // Alarmzustand holen
        $atop = html_entity_decode($_POST['ato' . $i], ENT_HTML5, "UTF-8");  // Alarm-Topic holen
        fwrite($afile, $aname . "\n");                    // Alarmname schreiben
        fwrite($afile, $aidle . "\n");                    // Ruhezustand schreiben
        fwrite($afile, $adeac . "\n");                    // Normalzustand schreiben
        fwrite($afile, $aactv . "\n");                    // Alarmzustand schreiben
        fwrite($afile, $atop . "\n");                     // Alarm-Topic schreiben
        fclose($afile);                                   // Alarmdatei schließen
        chmod($cfgdir . '/al' . $i, 0664);                // Rechte anpassen (pi darf schreiben)
      }
      $afile = fopen($cfgdir . '/change', "w");           // neue Change-Datei erstellen
      fclose($afile);                                     // und wieder schließen (hat dann 0 Bytes)
      $alok = 1;                                          // Flag für Bestätigung setzen
    }

    $serok = 0;                                           // Flag für Bestätigung löschen
    if (isset($_POST['cfgserv'])) {                       // wenn neuer Servername gesendet
      $servfile = fopen($sername, "w");                   // neue Servernamendatei erstellen
      $servname = html_entity_decode($_POST['servname'], ENT_HTML5, "UTF-8"); // Servername holen und konvertieren
      fwrite($servfile, $servname . "\n");                // Servername schreiben
      fclose($servfile);                                  // Servernamendatei schließen
      $serok = 1;                                         // Flag für Bestätigung setzen
    }
  ?>
  <br>
  <form name="Anzeige" action="<?php echo $_SERVER['SCRIPT_NAME']; ?>" method="post">
    <fieldset>
      <legend>Anzeige-Konfiguration</legend>
      <table class="t5">
        <tr><td>Diese Tabelle steuert die Darstellung der Sensor- und Alarmdaten auf der Seite
        <span class="x2">Sensoren</span>.</td></tr>
      </table>
      <table class="t4">
        <tr><th>Feldtyp</th><th colspan="2">Horizontal</th><th colspan="2">Vertikal</th>
        <th colspan="2">Element 1</th><th colspan="2">Element 2</th><th colspan="2">Element 3</tr>
        <tr class="sm"><td></td><td>Ausrichtung</td><td>Abstand</td><td>Ausrichtung</td><td>Abstand</td>
        <td>Typ</td><td>Parameter</td><td>Typ</td><td>Parameter</td><td>Typ</td><td>Parameter</td></tr>
        <?php
          if (!file_exists($wwwname)) {                                     // wenn Sensoranzeigedatei nicht vorhanden
            $senfile = fopen($wwwname, "w");                                // Datei erstellen
            fwrite($senfile, "hintergrundbild.png\n");                      // Name für Hintergrundbild speichern
            fclose($senfile);                                               // Datei schließen
            chmod($wwwname, 0664);                                          // Rechte anpassen (pi darf schreiben)
          }
          if (file_exists($wwwname)) {                                      // wenn Sensoranzeigedatei vorhanden
            $senfile = fopen($wwwname, "r");                                // Datei öffnen
            $pict = rtrim(fgets($senfile));                                 // Name für Hintergrundbild lesen
            $i = 1;                                                         // Zeilenzähler setzen
            do {                                                            // Schleife
              $senline = rtrim(fgets($senfile));                            // eine Zeile lesen
              $pos = strpos($senline, ",");                                 // Komma-Position ermitteln
              if ($pos !== false) {                                         // wenn Position gefunden
                $ftyp = substr($senline, 0, 1);                             // Feldtyp ermitteln
                if ($ftyp > 0 && $ftyp < 4) {                               // wenn Wert zwischen 1 und 3
                  $lpos = $pos;                                             // letzte Komma-Position merken
                  $pos = strpos($senline, ",", $lpos + 1);                  // nächste Komma-Position ermitteln
                  if ($pos !== false) {                                     // wenn Position gefunden
                    $xpos = substr($senline, $lpos + 1, $pos - $lpos - 1);  // X-Position ermitteln
                    if (substr($xpos, 0, 1) == 'l' || substr($xpos, 0, 1) == 'r') { // Position 'l' oder 'r'
                      $lpos = $pos;                                         // letzte Komma-Position merken
                      $pos = strpos($senline, ",", $lpos + 1);              // nächste Komma-Position ermitteln
                      if ($pos !== false) {                                 // wenn Position gefunden
                        $ypos = substr($senline, $lpos + 1, $pos - $lpos - 1); // Y-Position ermitteln
                        if (substr($ypos, 0, 1) == 't' || substr($ypos, 0, 1) == 'b') { // Position 't' oder 'b'
                          echo '<tr><td><select name="ftyp', $i, '" size="1"><option '; // Auswahlfeld für Feldtyp
                          if ($ftyp == 1) { echo 'selected '; }
                          echo 'value="1">Textfeld klein</option><option ';
                          if ($ftyp == 2) { echo 'selected '; }
                          echo 'value="2">Textfeld groß</option><option ';
                          if ($ftyp == 3) { echo 'selected '; }
                          echo 'value="3">Grafik</option><option ';
                          echo 'value="0">Löschen</option></select></td>';
                          echo '<td><select name="xdir', $i, '" size="1"><option '; // Auswahlfeld für Horizontal-Rich.
                          if (substr($xpos, 0, 1) == 'l') { echo 'selected '; }
                          echo 'value="l">links</option><option ';
                          if (substr($xpos, 0, 1) == 'r') { echo 'selected '; }
                          echo 'value="r">rechts</option></select></td>';
                          echo '<td><input type="text" size="4" maxlength="4"';     // Eingabefeld für Horizontal-Abst.
                          echo ' name="xpos', $i, '" value="', substr($xpos, 1), '"></td>';
                          echo '<td><select name="ydir', $i, '" size="1"><option '; // Auswahlfeld für Vertikal-Richt.
                          if (substr($ypos, 0, 1) == 't') { echo 'selected '; }
                          echo 'value="t">oben</option><option ';
                          if (substr($ypos, 0, 1) == 'b') { echo 'selected '; }
                          echo 'value="b">unten</option></select></td>';
                          echo '<td><input type="text" size="4" maxlength="4"';     // Eingabefeld für Vertikal-Abstand
                          echo ' name="ypos', $i, '" value="', substr($ypos, 1), '"></td>';
                          for ($j = 1; $j < 7; $j++) {                      // Schleife für 6 weitere Datenfelder
                            $lpos = $pos;                                   // letzte Komma-Position merken
                            $pos = strpos($senline, ",", $lpos + 1);        // nächste Komma-Position ermitteln
                            if ($pos !== false) {                           // wenn Position gefunden
                              $data = substr($senline, $lpos + 1, $pos - $lpos - 1); // Datenwert bis Komma ermitteln
                            }
                            else {                                          // wenn Position nicht gefunden
                              $data = substr($senline, $lpos + 1);          // Datenwert bis zum Zeilenende ermitteln
                              $pos = strlen($senline) - 1;                  // Position auf Stringende - 1 setzen
                            }
                            echo '<td><select name="dat', $i, '-', $j, '" size="1"><option '; // Auswahl-/Eingabefelder
                            if ($j > 2) {                                         // wenn Felder 3-6
                              if (substr($data, 2) == '') { echo 'selected '; }   // wenn keine Daten vorhanden
                              echo 'value="no">aus</option><option ';             // auf "aus" setzen
                            }
                            if (substr($data, 0, 2) == 'an') { echo 'selected '; }  // Auswahlfeld 1, 3 und 5
                            echo 'value="an">Alarmname</option><option ';
                            if (substr($data, 0, 2) == 'av') { echo 'selected '; }
                            echo 'value="av">Alarmwert</option><option ';
                            if (substr($data, 0, 2) == 'sn') { echo 'selected '; }
                            echo 'value="sn">Sensorname</option><option ';
                            if (substr($data, 0, 2) == 'sv') { echo 'selected '; }
                            echo 'value="sv">Sensorwert</option>';
                            if ($j == 1) {                                  // Sensorbelegung und Grafiksensor nur an
                              echo '<option ';                              // Auswahlfeld 1
                              if (substr($data, 0, 2) == 'sm') { echo 'selected '; }
                              echo 'value="sm">Sensorbelegung</option><option ';
                              if (substr($data, 0, 2) == 'gr') { echo 'selected '; }
                              echo 'value="gr">Grafiksensor</option>';
                            }
                            if ($j == 3) {                                  // Grafikfarbe nur an Auswahlfeld 3
                              echo '<option ';
                              if (substr($data, 0, 2) == 'co') { echo 'selected '; }
                              echo 'value="co">Grafikfarbe</option>';
                            }
                            echo '</select></td>' ;
                            $j++;                                           // nächstes Eingabefeld (2, 4 oder 6)
                            echo '<td><input type="text" size="6" maxlength="6"'; // Eingabefelder für die Werte
                            echo ' name="dat', $i, '-', $j, '" value="', substr($data, 2), '"></td>';
                          }
                          echo "</tr>\n";
                        }
                      }
                    }
                  }
                }
              }
              else {                                                        // wenn Zeile ohne Komma
                echo '<tr><td><select name="ftyp', $i, '" size="1">';       // Auswahlfeld für Feldtyp
                echo '<option value="1">Textfeld klein</option>';
                echo '<option value="2">Textfeld groß</option>';
                echo '<option value="3">Grafik</option></select></td>';
                echo '<td><select name="xdir', $i, '" size="1">';           // Auswahlfeld für Horizontal-Richtung
                echo '<option value="l">links</option>';
                echo '<option value="r">rechts</option></select></td>';
                echo '<td><input type="text" size="4" maxlength="4"';       // Eingabefeld für Horizontal-Abstand
                echo ' name="xpos', $i, '" value=""></td>';
                echo '<td><select name="ydir', $i, '" size="1">';           // Auswahlfeld für Vertikal-Richtung
                echo '<option value="t">oben</option>';
                echo '<option value="b">unten</option></select></td>';
                echo '<td><input type="text" size="4" maxlength="4"';
                echo ' name="ypos', $i, '" value=""></td>';
                for ($j = 1; $j < 7; $j++) {                                // Schleife für 6 Eingabefelder
                  echo '<td><select name="dat', $i, '-', $j, '" size="1">'; // Auswahlfeld für Datenfeld 1, 3 und 5
                  if ($j > 2) { echo '<option selected value="no">aus</option>'; }
                  echo '<option value="an">Alarmname</option>';
                  echo '<option value="av">Alarmwert</option>';
                  echo '<option value="sn">Sensorname</option>';
                  echo '<option value="sv">Sensorwert</option>';
                  if ($j == 1) {                                            // Sensorbelegung und Grafiksensor nur an
                    echo '<option value="sm">Sensorbelegung</option>';      // Auswahlfeld 1
                    echo '<option value="gr">Grafiksensor</option>';
                  }
                  if ($j == 3) { echo '<option value="co">Grafikfarbe</option>'; } // Grafikfarbe nur an Feld 3
                  echo '</select></td>' ;
                  $j++;                                                     // nächstes Eingabefeld (2, 4 oder 6)
                  echo '<td><input type="text" size="6" maxlength="6"';     // Eingabefelder für die Werte
                  echo ' name="dat', $i, '-', $j, '" value=""></td>';
                }
                echo "</tr>\n";
              }
              $i++;
            } while (!feof($senfile));                                      // Schleife bis Dateiende
            fclose($senfile);                                               // Sensoranzeigedatei schließen
          }
        ?>
      </table>
      <input type="hidden" name="end" value="<?php echo $i; ?>">
      <table class="t4">
        <tr><td><input type="text" size="40" name="bgpic" value="<?php echo $pict; ?>"></td>
        <td>Name der Hintergrundgrafik</td></tr>
      </table>
      <table class="t4">
        <tr><td><input type="submit" name="cfgwww" value="Anzeige-Konfiguration speichern"></td><td>
        <?php if ($wwwok == 1) { echo '<span class="m4">gespeichert</span>'; } ?>
        </td></tr>
      </table>
    </fieldset>
  </form>
  <br>
  <form name="Sensoren" action="<?php echo $_SERVER['SCRIPT_NAME']; ?>#Sensoren" method="post">
    <a id="Sensoren"></a>
    <fieldset>
      <legend>Sensor-Grundkonfiguration</legend>
      <table class="t5">
        <tr><td>In dieser Tabelle wird die Grundeinstellung der 31 Sensoren des Temperatur-Messsystems
        festgelegt.</td></tr>
      </table>
      <table class="t4">
        <tr><th>Nr</th><th>Sensorname</th><th>Min</th><th>Max</th><th>Sperre</th><th>MQTT Topic</th><th>Höhe</th></tr>
        <?php
          for ($i = 1; $i < 32; $i++) {                                     // 32 Sensoren bearbeiten
            echo '<tr><td>', $i, '</td>';                                   // Nummer ausgeben
            if (file_exists($cfgdir . '/s' . $i)) {                         // wenn Sensordatei vorhanden
              $sfile = fopen($cfgdir . '/s' . $i, "r");                     // Sensordatei öffnen
              $sname = htmlentities(rtrim(fgets($sfile, 100)), ENT_HTML5, "UTF-8"); // Sensorname lesen und konvert.
              $smin = rtrim(fgets($sfile, 10));                             // Minimalwert lesen
              $smax = rtrim(fgets($sfile, 10));                             // Maximalwert lesen
              $slock = rtrim(fgets($sfile, 10));                            // Sperre lesen
              $stop = htmlentities(rtrim(fgets($sfile, 100)), ENT_HTML5, "UTF-8");
              fclose($sfile);                                               // Sensordatei schließen
              echo '<td><input type="text" size="25" maxlength="50"';       // Eingabefeld für Sensorname
              echo ' name="sen', $i, '" value="', $sname, '"></td>';
              echo '<td><input type="text" size="3"';                       // Eingabefeld für Minimalwert
              echo ' name="min', $i, '" value="', $smin, '"></td>';
              echo '<td><input type="text" size="3"';                       // Eingabefeld für Maximalwert
              echo ' name="max', $i, '" value="', $smax, '"></td>';
              echo '<td><input type="checkbox"';                            // Checkbox für Sperre
              echo ' name="lck', $i, '" value="1"';
              if ($slock != 0) { echo ' checked'; }
              echo '></td>';
              echo '<td><input type="text" size="60" maxlength="100"';      // Eingabefeld für Topic
              echo ' name="top', $i, '" value="', $stop, '"></td>';
              if ($i == 28) {                                               // wenn Luftdrucksensor
                if (file_exists($cfgdir . '/height')) {                     // wenn Höhendatei vorhanden
                  $sfile = fopen($cfgdir . '/height', "r");                 // Höhendatei öffnen
                  $height = rtrim(fgets($sfile, 10));                       // Höhenwert lesen
                  fclose($sfile);                                           // Höhendatei schließen
                }
                else { $height = 0; }                                       // wenn keine Höhendatei -> Höhe = 0
                echo '<td><input type="text" size="5"';                     // Eingabefeld für Höhenwert
                echo ' name="height" value="', $height, '"></td>';
              }
              else { echo '<td></td>'; }                                    // wenn kein Luftdrucksensor -> Feld leer
            }
            else {                                                          // wenn Sensordatei nicht vorhanden
              echo '<td><input type="text" size="25" maxlength="50"';       // Eingabefeld für Sensorname
              echo ' name="sen', $i, '" value="Sensor', $i, '"></td>';      // mit "SensorXX" vorbelegen
              echo '<td><input type="text" size="3"';                       // Eingabefeld für Minimalwert
              echo ' name="min', $i, '" value=""></td>';                    // nicht vorbelegen
              echo '<td><input type="text" size="3"';                       // Eingabefeld für Maximalwert
              echo ' name="max', $i, '" value=""></td>';                    // nicht vorbelegen
              echo '<td><input type="Checkbox"';                            // Checkbox für Sperre
              echo ' name="lck', $i, '" value="1" checked></td>';           // aktivieren
              echo '<td><input type="text" size="60" maxlength="100"';      // Eingabefeld für Topic
              echo ' name="top', $i, '" value=""></td>';                    // nicht vorbelegen
              if ($i == 28) {                                               // wenn Luftdrucksensor
                if (file_exists($cfgdir . '/height')) {                     // wenn Höhendatei vorhanden
                  $sfile = fopen($cfgdir . '/height', "r");                 // Höhendatei öffnen
                  $height = rtrim(fgets($sfile, 10));                       // Höhenwert lesen
                  fclose($sfile);                                           // Höhendatei schließen
                }
                else { $height = 0; }                                       // wenn keine Höhendatei -> Höhe = 0
                echo '<td><input type="text" size="5"';                     // Eingabefeld für Höhenwert
                echo ' name="height" value="', $height, '"></td>';
              }
              else { echo '<td></td>'; }                                    // wenn kein Luftdrucksensor -> Feld leer
            }
            echo "</tr>\n";
          }
        ?>
      </table>
      <table class="t4">
        <tr><td><input type="submit" name="cfgsen" value="Sensor-Grundkonfiguration speichern"></td><td>
        <?php if ($senok == 1) { echo '<span class="m4">gespeichert</span>'; } ?>
        </td></tr>
      </table>
    </fieldset>
  </form>
  <br>
  <form name="Alarme" action="<?php echo $_SERVER['SCRIPT_NAME']; ?>#Alarme" method="post">
    <a id="Alarme"></a>
    <fieldset>
      <legend>Alarm-Grundkonfiguration</legend>
      <table class="t5">
        <tr><td>In dieser Tabelle wird die Grundeinstellung der 4 Alarme des Temperatur-Messsystems
        festgelegt.</td></tr>
      </table>
      <table class="t4">
        <tr><th>Nr</th><th>Alarmname</th><th>Ruhezustand</th><th>Normalzustand</th><th>Alarmzustand</th><th>MQTT Topic</th></tr>
        <?php
          for ($i = 1; $i < 5; $i ++) {                                     // 4 Alarme bearbeiten
            echo '<tr><td>', $i, '</td>';                                   // Nummer ausgeben
            if (file_exists($cfgdir . '/al' . $i)) {                        // wenn Alarmdatei vorhanden
              $afile = fopen($cfgdir . '/al' . $i, "r");                    // Alarmdatei öffnen
              $aname = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8"); // Alarmname lesen und konvert.
              $aidle = rtrim(fgets($afile, 10));                                    // Ruhezustand lesen
              $adeac = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8"); // Normalzustand lesen und konv.
              $aactv = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8"); // Alarmzustand lesen und konv.
              $atop = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8");
              fclose($afile);                                               // Alarmdatei schließen
              echo '<td><input type="text" size="25" maxlength="50"';       // Eingabefeld für Alarmname
              echo ' name="aln', $i, '" value="', $aname, '"></td>';
              echo '<td><select name="aid', $i, '" size="1"><option ';      // Auswahlfeld für Ruhezustand
              if ($aidle == 0) { echo 'selected '; }
              echo 'value="0">Kontakt offen</option><option ';
              if ($aidle == 1) { echo 'selected '; }
              echo 'value="1">Kontakt geschlossen</option></select></td>';
              echo '<td><input type="text" size="16" maxlength="50"';       // Eingabefeld für Normalzustand
              echo ' name="ade', $i, '" value="', $adeac, '"></td>';
              echo '<td><input type="text" size="16" maxlength="50"';       // Eingabefeld für Alarmzustand
              echo ' name="aac', $i, '" value="', $aactv, '"></td>';
              echo '<td><input type="text" size="60" maxlength="100"';      // Eingabefeld für Alarm-Topic
              echo ' name="ato', $i, '" value="', $atop, '"></td>';
            }
            else {                                                          // wenn Alarmdatei nicht vorhanden
              echo '<td><input type="text" size="25" maxlength="50"';       // Eingabefeld für Alarmname
              echo ' name="aln', $i, '" value="Alarm', $i, '"></td>';       // mit "AlarmX" vorbelegen
              echo '<td><select name="aid', $i, '" size="1">';              // Auswahlfeld für Ruhezustand
              echo '<option selected value="0">Kontakt offen</option>';     // mit "Kontakt offen" vorbelegen
              echo '<option value="1">Kontakt geschlossen</option></select></td>';
              echo '<td><input type="text" size="16" maxlength="50"';       // Eingabefeld für Normalzustand
              echo ' name="ade', $i, '" value="aus"></td>';                 // mit "aus" vorbelegen
              echo '<td><input type="text" size="16" maxlength="50"';       // Eingabefeld für Alarmzustand
              echo ' name="aac', $i, '" value="ein"></td>';                 // mit "ein" vorbelegen
              echo '<td><input type="text" size="60" maxlength="100"';      // Eingabefeld für Alarm-Topic
              echo ' name="ato', $i, '" value=""></td>';                    // nicht vorbelegen
            }
            echo "</tr>\n";
          }
        ?>
      </table>
      <table class="t4">
        <tr><td><input type="submit" name="cfgalm" value="Alarm-Grundkonfiguration speichern"></td><td>
        <?php if ($alok == 1) { echo '<span class="m4">gespeichert</span>'; } ?>
        </td></tr>
      </table>
    </fieldset>
  </form>
  <br>
  <form name="Server" action="<?php echo $_SERVER['SCRIPT_NAME']; ?>#Server" method="post">
    <a id="Server"></a>
    <fieldset>
      <legend>Servername</legend>
      <table class="t4">
        <?php
          $servname = 'Mein Web-Server';                                    // Default-Servername setzen
          if (file_exists('server.dat')) {                                  // wenn Servernamendatei vorhanden
            $servfile = fopen('server.dat', "r");                           // Servernamendatei öffnen
            $servname = htmlentities(rtrim(fgets($servfile)), ENT_HTML5, "UTF-8"); // Servername lesen und konvert.
            fclose($servfile);                                              // Datei schließen
          }
          echo '<tr><td><input type="text" size="25" maxlength="50" ';      // Eingabefeld für Servername
          echo 'name="servname" value="', $servname, '"></td></tr>';
        ?>
      </table>
      <table class="t4">
        <tr><td><input type="submit" name="cfgserv" value="Servername speichern"></td><td>
        <?php if ($serok == 1) { echo '<span class="m4">gespeichert</span>'; } ?>
        </td></tr>
      </table>
    </fieldset>
  </form>
</body>
</html>
