<!doctype html>
<html lang="de">
<head>
  <?php include 'title.php'; ?>
  <meta charset="utf-8">
  <meta http-equiv="refresh" content="60">
  <meta name="author" content="Scott Falk Hühn">
  <meta name="editor" content="GNU nano 2.7.4">
  <meta name="robots" content="noindex">
  <meta name="date" content="2018-06-04">
  <link rel="shortcut icon" href="favicon.ico">
  <link rel="apple-touch-icon" href="icon.png">
  <link rel="apple-touch-icon-precomposed" href="icon.png">
  <link rel="stylesheet" href="style.css" type="text/css">
</head>
<body>
  <?php
    include 'menu.php';                                             // Menü einbinden
    $sendir = "/mnt/ram";                                           // Verzeichnis für Sensorwerte
    $logdir = "/srv/sensor";                                        // Verzeichnis für Log-Daten
    $cfgdir = "/srv/sensor";                                        // Verzeichnis für Konfig-Daten
    $rrdfile = "/srv/sensor/sensor.rrd";                            // Verzeichnis und Name der Datenbank
    $komma  = ",";                                                  // Trennzeichen für Sensorwerte (. oder ,)

    function psn($snum) {                                           // Sensorname ausgeben
      global $cfgdir;
      if ($snum > 0 and $snum < 32) {                               // wenn gültige Sensornummer
        if (file_exists($cfgdir . "/s" . $snum)) {                  // wenn Konfigurationsdatei vorhanden
          $sfile = fopen($cfgdir . "/s" . $snum, "r");              // Konfigurationsdatei öffnen
          $sname = htmlentities(rtrim(fgets($sfile, 100)), ENT_HTML5, "UTF-8"); // Sensorname holen
          fclose($sfile);                                           // und konvertieren
          echo $sname;                                              // Sensorname ausgeben
        }
        else { echo 'Sensor', $snum; }                              // sonst Ersatztext ausgeben
      }
    }

    function psv($snum) {                                           // Sensorwert ausgeben
      global $sendir, $cfgdir, $komma;
      if ($snum > 0 and $snum < 32) {                               // wenn gültige Sensornummer
        if (file_exists($sendir . "/s" . $snum)) {                  // wenn Sensorwert vorhanden
          if (time() - filemtime($sendir . "/s" . $snum) < 100) {   // Dateizeit prüfen
            if ($sfile = fopen($sendir . "/s" . $snum, "r")) {      // Wertedatei öffnen
              $sval = rtrim(fgets($sfile, 10));                     // Sensorwert holen
              fclose($sfile);                                       // Wertedatei schließen
              if (file_exists($cfgdir . "/s" . $snum)) {            // wenn Konfigurationsdatei vorhanden
                $sfile = fopen($cfgdir . "/s" . $snum, "r");        // Konfigurationsdatei öffnen
                $sname = fgets($sfile, 100);                        // Sensorname holen (Dummy)
                $smin = rtrim(fgets($sfile, 10));                   // Minimalwert holen
                $smax = rtrim(fgets($sfile, 10));                   // Maximalwert holen
                fclose($sfile);                                     // Konfigurationsdatei schließen
              }
              else {                                                // wenn Konfigurationdatei nicht vorhanden
                $smin = '';                                         // Minimalwert löschen
                $smax = '';                                         // Maximalwert löschen
              }
              if (is_numeric($smin) and $sval < $smin) {            // wenn Minimalwert unterschritten
                echo '<span class="sn1">';                          // Alarmfarbe verwenden
              }
              elseif (is_numeric($smax) and $sval > $smax) {        // wenn Maximalwert überschritten
                echo '<span class="sn1">';                          // Alarmfarbe verwenden
              }
              else { echo '<span class="sn0">'; }                   // sonst Normalfarbe verwenden
              $sval = str_replace(".", $komma, $sval);              // Trennzeichen ersetzen
              echo $sval;                                           // Sensorwert ausgeben
              if ($snum < 28) { echo " &deg;C"; }                   // Temperatureinheit ergänzen
              if ($snum == 28) { echo " hPa"; }                     // Luftdruckeinheit ergänzen
              if ($snum > 28) { echo " %"; }                        // Luftfeuchtigkeitseinheit ergänzen
              echo "</span>";
            }
            else { echo '<span class="sn1">-----</span>'; }         // Sensorwert ist nicht aktuell
          }
          else { echo '<span class="sn1">-----</span>'; }           // Wertedatei lässt sich nicht öffnen
        }
        else { echo '<span class="sn1">-----</span>'; }             // kein Sensorwert vorhanden
      }
    }

    function psm() {                                                // Sensorbelegung ausgeben
      global $logdir;
      echo "Sensorbelegung<br>";
      if (file_exists($logdir . "/sen")) {                          // wenn Sensorbelegung vorhanden
        $smfile = fopen($logdir . "/sen", "r");                     // Sensorbelegungsdatei öffnen
        $smap = rtrim(fgets($smfile, 100));                         // Sensorbelegung holen
        fclose($smfile);                                            // Sensorbelegungsdatei schließen
        echo $smap;                                                 // Sensorbelegung ausgeben
      }
      else { echo "nicht vorhanden"; }                              // keine Sensorbelegung vorhanden
    }

    function aln($anum) {                                           // Alarmname ausgeben
      global $cfgdir;
      if ($anum > 0 and $anum < 5) {                                // wenn gültige Alarmnummer
        if (file_exists($cfgdir . "/al" . $anum)) {                 // wenn Konfigurationsdatei vorhanden
          $afile = fopen($cfgdir . "/al" . $anum, "r");             // Konfigurationsdatei öffnen
          $aname = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8"); // Alarmname holen
          fclose($afile);                                           // und konvertieren
          echo $aname;                                              // Alarmname ausgeben
        }
        else { echo 'Alarm', $anum; }                               // sonst Ersatztext ausgeben
      }
    }

    function alv($anum) {                                           // Alarmwert ausgeben
      global $sendir, $cfgdir;
      if ($anum > 0 and $anum < 5) {                                // wenn gültige Alarmnummer
        if (file_exists($cfgdir . "/al" . $anum)) {                 // wenn Konfigurationsdatei vorhanden
          $afile = fopen($cfgdir . "/al" . $anum, "r");             // Konfigurationsdatei öffnen
          $aname = fgets($afile, 100);                              // Alarmname holen (Dummy)
          $aidle = rtrim(fgets($afile, 10));                        // Alarm-Ruhezustand holen
          $adeac = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8"); // Normalstatustext holen
          $aactv = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8"); // Alarmstatustext holen
          fclose($afile);                                           // Konfigurationsdatei schließen
        }
        else {                                                      // wenn Konfigurationsdatei nicht vorhanden
          $aidle = 0;                                               // Ruhezustand setzen
          $adeac = 'Fehler';                                        // Normaltext setzen
          $aactv = 'Fehler';                                        // Alarmtext setzen
        }
        if (file_exists($sendir . "/al" . $anum)) {                 // wenn Alarmwert vorhanden
          if (time() - filemtime($sendir . "/al" . $anum) < 45) {   // Dateizeit prüfen
            if ($afile = fopen($sendir . "/al" . $anum, "r")) {     // Wertedatei öffnen
              $aval = rtrim(fgets($afile, 10));                     // Alarmwert holen
              fclose($afile);                                       // Wertedatei schließen
              if ($aval == $aidle) { echo '<span class="al0">', $adeac, "</span>"; } // Normalstatustext ausgeben
              else { echo '<span class="al1">', $aactv, "</span>"; } // oder Alarmstatustext ausgeben
            }
            else { echo '<span class="al1">-----</span>'; }         // Alarmwert ist nicht aktuell
          }
          else { echo '<span class="al1">-----</span>'; }           // Wertedatei lässt sich nicht öffnen
        }
        else { echo '<span class="al1">-----</span>'; }             // kein Alarmwert vorhanden
      }
    }

    function grph($snum, $color) {                                  // kleine Sensorgrafik ausgeben
      global $cfgdir, $rrdfile;
      if ($snum > 0 and $snum < 32) {                               // wenn gültige Sensornummer
        if (file_exists($cfgdir . "/s" . $snum)) {                  // wenn Konfigurationsdatei vorhanden
          $sfile = fopen($cfgdir . "/s" . $snum, "r");              // Konfigurationsdatei öffnen
          $sname = rtrim(fgets($sfile, 100));                       // Sensorname holen
          fclose($sfile);                                           // Konfigurationsdatei schließen
        }
        else { $sname = 'Sensor' . $snum; }                         // sonst Ersatztext setzen
        $sdata = "s" . $snum;                                       // Sensorname für Datenbank generieren
        $grname = "s" . $snum . ".png";                             // Dateiname für Grafik generieren
        rrd_graph("$grname",                                        // Grafik erzeugen
          array(
            "-s-36h",                                               // Anzeige der letzten 36 Stunden
            "-D",                                                   // Breite und Höhe entspricht dem Außenmaß
            "-w320",                                                // Breite 320 Pixel
            "-h100",                                                // Höhe 100 Pixel
            "-E",                                                   // Weiche Kantendarstellung
            "-A",                                                   // Automatische Y-Skalierung
            "-y1:4",                                                // Raster 1, Beschriftung 4 Einheiten
            "-X0",                                                  // Exponent 0
            "-v$sname",                                             // Y-Skala mit Sensorname beschriften
            "DEF:var=$rrdfile:$sdata:AVERAGE",                      // Mittelwert anzeigen
            "LINE2:var#$color"                                      // Line 2 Pixel in festgelegter Farbe
          )
        );
        echo "<img src=\"$grname\" alt=\"Minigrafik\">";            // Grafik ausgeben
      }
    }

    $senfile = fopen("sensor.dat", "r");                            // Sensordatei öffnen
    $senline = rtrim(fgets($senfile));                              // erste Zeile lesen, enthält Name der Grafik
    if ($senline > '') {                                            // wenn Grafikname vorhanden
      if (file_exists($senline)) {                                  // wenn Grafikdatei vorhanden
        list($width, $height) = getimagesize($senline);             // Breite und Höhe ermitteln
      }
    }
    if (!isset($width)) {                                           // wenn keine gültige Breite vorhanden
      $senline = 'noname';                                          // Dummy-Name setzen
      $width = 800;                                                 // Breite auf 800 Pixel setzen
      $height = 600;                                                // Höhe auf 600 Pixel setzen
    }
    echo '<div class="house" style="width:', $width, 'px; heigth:', $height, 'px">'; // HTML-Abschnitt definieren
    echo '<img src="', $senline, '" alt="Hintergrundbild">', "\n";  // Grafik ausgeben

    while (!feof($senfile)) {                                       // Schleife bis zum Ende der Sensordatei
      $senline = rtrim(fgets($senfile));                            // eine Zeile lesen
      $pos = strpos($senline, ",");                                 // Komma-Position ermitteln
      if ($pos !== false) {                                         // wenn Position gefunden
        $class = substr($senline, 0, 1);                            // Style-Class ermitteln
        if ($class > 0 && $class < 4) {                             // wenn Wert zwischen 1 und 3
          $lpos = $pos;                                             // letzte Komma-Position merken
          $pos = strpos($senline, ",", $lpos + 1);                  // nächste Komma-Position ermitteln
          if ($pos !== false) {                                     // wenn Position gefunden
            $xpos = substr($senline, $lpos + 1, $pos - $lpos - 1);  // X-Position ermitteln
            if (substr($xpos, 0, 1) == 'l' || substr($xpos, 0, 1) == 'r') { // Position beginnt mit 'l' oder 'r'
              if (substr($xpos, 0, 1) == 'l') { $xdir = 'left:'; }  // zum entsprechenden String erweitern
              else { $xdir = 'right:'; }
              $lpos = $pos;                                         // letzte Komma-Position merken
              $pos = strpos($senline, ",", $lpos + 1);              // nächste Komma-Position ermitteln
              if ($pos !== false) {                                 // wenn Position gefunden
                $ypos = substr($senline, $lpos + 1, $pos - $lpos - 1); // Y-Position ermitteln
                if (substr($ypos, 0, 1) == 't' || substr($ypos, 0, 1) == 'b') { // Position beginnt mit 't' oder 'b'
                  if (substr($ypos, 0, 1) == 't') { $ydir = 'top:'; } // zum entsprechenden String erweitern
                  else { $ydir = 'bottom:'; }
                  echo '<span class="t', $class, '" style="', $xdir;  // HTML-Code (Style und Koordinaten) ausgeben
                  echo substr($xpos, 1), 'px; ', $ydir, substr($ypos, 1), 'px">';
                  $count = 0;                                       // Umbruch-Zähler löschen
                  $graph = 0;                                       // Grafik-Sensor löschen
                  do {                                              // Schleife
                    $lpos = $pos;                                   // letzte Komma-Position merken
                    $pos = strpos($senline, ",", $lpos + 1);        // nächste Komma-Position ermitteln
                    if ($pos !== false) {                           // wenn Position gefunden
                      $data = substr($senline, $lpos + 1, $pos - $lpos - 1); // Datenwert bis zum Komma ermitteln
                    }
                    else {                                          // wenn Position nicht gefunden
                      $data = substr($senline, $lpos + 1);          // Datenwert bis zum Zeilenende ermitteln
                    }
                    if ($count > 0 && $graph == 0) { echo '<br>'; } // wenn nicht erster Datenwert und keine Grafik ->
                    $count++;                                       // Zeilenumbruch ausgeben, Umbruch-Zähler erhöhen
                    if (substr($data, 0, 2) == 'an') { aln(substr($data, 2)); }     // Funktion Alarmname aufrufen
                    if (substr($data, 0, 2) == 'av') { alv(substr($data, 2)); }     // Funktion Alarmwert aufrufen
                    if (substr($data, 0, 2) == 'sn') { psn(substr($data, 2)); }     // Funktion Sensorname aufrufen
                    if (substr($data, 0, 2) == 'sv') { psv(substr($data, 2)); }     // Funktion Sensorwert aufrufen
                    if (substr($data, 0, 2) == 'sm') { psm(); }                     // Funktion Sensorbelegung aufrufen
                    if (substr($data, 0, 2) == 'gr') { $graph = substr($data, 2); } // Grafik-Sensor ermitteln
                    if (substr($data, 0, 2) == 'co') {
                      grph($graph, substr($data, 2));               // Funktion Grafik aufrufen
                      $graph = 0;                                   // anschließend Grafik-Sensor wieder löschen
                    }
                  } while ($pos !== false);                         // Schleife beenden, wenn kein weiteres Komma
                  echo "</span>\n";                                 // gefunden, HTML-Code ausgeben
                }
              }
            }
          }
        }
      }
    }
    fclose($senfile);                                               // Sensordatei schließen
    echo "</div>\n";                                                // HTML-Abschnitt schließen
  ?>
</body>
</html>
