<!doctype html>
<html lang="de">
<head>
  <?php include 'title.php'; ?>
  <meta charset="utf-8">
  <meta name="author" content="Scott Falk Hühn">
  <meta name="editor" content="GNU nano 2.7.4">
  <meta name="robots" content="noindex">
  <meta name="date" content="2018-06-04">
  <link rel="shortcut icon" href="favicon.ico">
  <link rel="apple-touch-icon" href="icon.png">
  <link rel="apple-touch-icon-precomposed" href="icon.png">
  <link rel="stylesheet" href="style.css" type="text/css">
</head>
<body>
  <?php
    include 'menu.php';
    $width   = 380;
    $height  = 100;
    $infile  = "/var/www/lighttpd.rrd";
    $disp = array(
      "-w$width",
      "-h$height",
      "-vBytes",
      "DEF:binraw=$infile:InOctets:AVERAGE",
      "DEF:binmaxraw=$infile:InOctets:MAX",
      "DEF:binminraw=$infile:InOctets:MIN",
      "DEF:bout=$infile:OutOctets:AVERAGE",
      "DEF:boutmax=$infile:OutOctets:MAX",
      "DEF:boutmin=$infile:OutOctets:MIN",
      "CDEF:bin=binraw,-1,*",
      "CDEF:binmax=binmaxraw,-1,*",
      "CDEF:binmin=binminraw,-1,*",
      "CDEF:binminmax=binmaxraw,binminraw,-",
      "CDEF:boutminmax=boutmax,boutmin,-",
      "AREA:binmin#ffffff:",
      "STACK:binmax#f00000:",
      "LINE1:binmin#a0a0a0:",
      "LINE1:binmax#a0a0a0:",
      "LINE2:bin#efb71d:In",
      "GPRINT:bin:MIN:%.1lf%s",
      "GPRINT:bin:AVERAGE:%.1lf%s",
      "GPRINT:bin:MAX:%.1lf%s",
      "AREA:boutmin#ffffff:",
      "STACK:boutminmax#00f000:",
      "LINE1:boutmin#a0a0a0:",
      "LINE1:boutmax#a0a0a0:",
      "LINE2:bout#a0a735:Out",
      "GPRINT:bout:MIN:%.1lf%s",
      "GPRINT:bout:AVERAGE:%.1lf%s",
      "GPRINT:bout:MAX:%.1lf%s"
    );
    $graph1 = array("-s-14400", "-tDatenverkehr (4 Stunden)");
    $graph2 = array("-s-1d", "-tDatenverkehr (Tag)");
    $graph3 = array("-s-30d", "-tDatenverkehr (Monat)");
    rrd_graph("traffic-hou.png", array_merge($graph1, $disp));
    rrd_graph("traffic-day.png", array_merge($graph2, $disp));
    rrd_graph("traffic-mon.png", array_merge($graph3, $disp));
    $disp = array(
      "-w$width",
      "-h$height",
      "-vAnzahl",
      "-u1",
      "DEF:req=$infile:Requests:AVERAGE",
      "DEF:reqmax=$infile:Requests:MAX",
      "DEF:reqmin=$infile:Requests:MIN",
      "CDEF:reqminmax=reqmax,reqmin,-",
      "AREA:reqmin#ffffff:",
      "STACK:reqminmax#00f000:",
      "LINE1:reqmin#a0a0a0:",
      "LINE1:reqmax#a0a0a0:",
      "LINE2:req#00a735:Anfragen"
    );
    $graph1 = array("-s-14400", "-tAnfragen pro Sekunde (4 Stunden)");
    $graph2 = array("-s-1d", "-tAnfragen pro Sekunde (Tag)");
    $graph3 = array("-s-30d", "-tAnfragen pro Sekunde (Monat)");
    rrd_graph("requests-hou.png", array_merge($graph1, $disp));
    rrd_graph("requests-day.png", array_merge($graph2, $disp));
    rrd_graph("requests-mon.png", array_merge($graph3, $disp));
  ?>
  <p>
    <img src="traffic-hou.png" style="float:left; margin-right:4px; margin-bottom:4px" alt="Grafik 1">
    <img src="requests-hou.png" style="margin-bottom:4px" alt="Grafik 4"> <br style="clear:both">
    <img src="traffic-day.png" style="float:left; margin-right:4px; margin-bottom:4px" alt="Grafik 2">
    <img src="requests-day.png" style="margin-bottom:4px" alt="Grafik 5"> <br style="clear:both">
    <img src="traffic-mon.png" style="float:left; margin-right:4px; margin-bottom:4px" alt="Grafik 3">
    <img src="requests-mon.png" style="margin-bottom:4px" alt="Grafik 6"> <br style="clear:both">
  </p>
</body>
</html>
