<!doctype html>
<html lang="de">
<head>
  <?php include 'title.php'; ?>
  <meta charset="utf-8">
  <meta http-equiv="refresh" content="60">
  <meta name="author" content="Scott Falk Hühn">
  <meta name="editor" content="GNU nano 2.7.4">
  <meta name="robots" content="noindex">
  <meta name="date" content="2018-06-04">
  <link rel="shortcut icon" href="favicon.ico">
  <link rel="apple-touch-icon" href="icon.png">
  <link rel="apple-touch-icon-precomposed" href="icon.png">
  <link rel="stylesheet" href="style.css" type="text/css">
</head>
<body>
  <?php
    include 'menu.php';                                             // Menü einbinden
    $sendir = "/mnt/ram";                                           // Verzeichnis für Sensorwerte
    $logdir = "/srv/sensor";                                        // Verzeichnis für Log-Daten
    $cfgdir = "/srv/sensor";                                        // Verzeichnis für Konfig-Daten
    $komma  = ",";                                                  // Trennzeichen für Sensorwerte (. oder ,)

    function psn($snum) {                                           // Sensorname ausgeben
      global $cfgdir;
      if ($snum > 0 and $snum < 32) {                               // wenn gültige Sensornummer
        if (file_exists($cfgdir . "/s" . $snum)) {                  // wenn Konfigurationsdatei vorhanden
          $sfile = fopen($cfgdir . "/s" . $snum, "r");              // Konfigurationsdatei öffnen
          $sname = htmlentities(rtrim(fgets($sfile, 100)), ENT_HTML5, "UTF-8"); // Sensorname holen
          fclose($sfile);                                           // und konvertieren
          echo $sname;                                              // Sensorname ausgeben
        }
        else { echo 'Sensor', $snum; }                              // sonst Ersatztext ausgeben
      }
    }

    function psv($snum) {                                           // Sensorwert ausgeben
      global $sendir, $cfgdir, $komma;
      if ($snum > 0 and $snum < 32) {                               // wenn gültige Sensornummer
        if (file_exists($sendir . "/s" . $snum)) {                  // wenn Sensorwert vorhanden
          if (time() - filemtime($sendir . "/s" . $snum) < 100) {   // Dateizeit prüfen
            if ($sfile = fopen($sendir . "/s" . $snum, "r")) {      // Wertedatei öffnen
              $sval = rtrim(fgets($sfile, 10));                     // Sensorwert holen
              fclose($sfile);                                       // Wertedatei schließen
              if (file_exists($cfgdir . "/s" . $snum)) {            // wenn Konfigurationsdatei vorhanden
                $sfile = fopen($cfgdir . "/s" . $snum, "r");        // Konfigurationsdatei öffnen
                $sname = fgets($sfile, 100);                        // Sensorname holen (Dummy)
                $smin = rtrim(fgets($sfile, 10));                   // Minimalwert holen
                $smax = rtrim(fgets($sfile, 10));                   // Maximalwert holen
                fclose($sfile);                                     // Konfigurationsdatei schließen
              }
              else {                                                // wenn Konfigurationdatei nicht vorhanden
                $smin = '';                                         // Minimalwert löschen
                $smax = '';                                         // Maximalwert löschen
              }
              if (is_numeric($smin) and $sval < $smin) {            // wenn Minimalwert unterschritten
                echo '<span class="sn1">';                          // Alarmfarbe verwenden
              }
              elseif (is_numeric($smax) and $sval > $smax) {        // wenn Maximalwert überschritten
                echo '<span class="sn1">';                          // Alarmfarbe verwenden
              }
              else { echo '<span class="sn0">'; }                   // sonst Normalfarbe verwenden
              $sval = str_replace(".", $komma, $sval);              // Trennzeichen ersetzen
              echo $sval;                                           // Sensorwert ausgeben
              if ($snum < 28) { echo " &deg;C"; }                   // Temperatureinheit ergänzen
              if ($snum == 28) { echo " hPa"; }                     // Luftdruckeinheit ergänzen
              if ($snum > 28) { echo " %"; }                        // Luftfeuchtigkeitseinheit ergänzen
              echo "</span>";
            }
            else { echo '<span class="sn1">-----</span>'; }         // Sensorwert ist nicht aktuell
          }
          else { echo '<span class="sn1">-----</span>'; }           // Wertedatei lässt sich nicht öffnen
        }
        else { echo '<span class="sn1">-----</span>'; }             // kein Sensorwert vorhanden
      }
    }

    function psm() {                                                // Sensorbelegung ausgeben
      global $logdir;
      echo "Sensorbelegung<br>";
      if (file_exists($logdir . "/sen")) {                          // wenn Sensorbelegung vorhanden
        $smfile = fopen($logdir . "/sen", "r");                     // Sensorbelegungsdatei öffnen
        $smap = rtrim(fgets($smfile, 100));                         // Sensorbelegung holen
        fclose($smfile);                                            // Sensorbelegungsdatei schließen
        echo $smap;                                                 // Sensorbelegung ausgeben
      }
      else { echo "nicht vorhanden"; }                              // keine Sensorbelegung vorhanden
    }

    function aln($anum) {                                           // Alarmname ausgeben
      global $cfgdir;
      if ($anum > 0 and $anum < 5) {                                // wenn gültige Alarmnummer
        if (file_exists($cfgdir . "/al" . $anum)) {                 // wenn Konfigurationsdatei vorhanden
          $afile = fopen($cfgdir . "/al" . $anum, "r");             // Konfigurationsdatei öffnen
          $aname = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8"); // Alarmname holen
          fclose($afile);                                           // und konvertieren
          echo $aname;                                              // Alarmname ausgeben
        }
        else { echo 'Alarm', $anum; }                               // sonst Ersatztext ausgeben
      }
    }

    function alv($anum) {                                           // Alarmwert ausgeben
      global $sendir, $cfgdir;
      if ($anum > 0 and $anum < 5) {                                // wenn gültige Alarmnummer
        if (file_exists($cfgdir . "/al" . $anum)) {                 // wenn Konfigurationsdatei vorhanden
          $afile = fopen($cfgdir . "/al" . $anum, "r");             // Konfigurationsdatei öffnen
          $aname = fgets($afile, 100);                              // Alarmname holen (Dummy)
          $aidle = rtrim(fgets($afile, 10));                        // Alarm-Ruhezustand holen
          $adeac = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8"); // Normalstatustext holen
          $aactv = htmlentities(rtrim(fgets($afile, 100)), ENT_HTML5, "UTF-8"); // Alarmstatustext holen
          fclose($afile);                                           // Konfigurationsdatei schließen
        }
        else {                                                      // wenn Konfigurationsdatei nicht vorhanden
          $aidle = 0;                                               // Ruhezustand setzen
          $adeac = 'Fehler';                                        // Normaltext setzen
          $aactv = 'Fehler';                                        // Alarmtext setzen
        }
        if (file_exists($sendir . "/al" . $anum)) {                 // wenn Alarmwert vorhanden
          if (time() - filemtime($sendir . "/al" . $anum) < 45) {   // Dateizeit prüfen
            if ($afile = fopen($sendir . "/al" . $anum, "r")) {     // Wertedatei öffnen
              $aval = rtrim(fgets($afile, 10));                     // Alarmwert holen
              fclose($afile);                                       // Wertedatei schließen
              if ($aval == $aidle) { echo '<span class="al0">', $adeac, "</span>"; } // Normalstatustext ausgeben
              else { echo '<span class="al1">', $aactv, "</span>"; } // oder Alarmstatustext ausgeben
            }
            else { echo '<span class="al1">-----</span>'; }         // Alarmwert ist nicht aktuell
          }
          else { echo '<span class="al1">-----</span>'; }           // Wertedatei lässt sich nicht öffnen
        }
        else { echo '<span class="al1">-----</span>'; }             // kein Alarmwert vorhanden
      }
    }
  ?>

  <table class="t2" style="margin-top:20px; margin-right:30px; float:left">
    <tr><th></th><th>Sensor</th><th>Wert</th></tr>
    <tr><td>1</td><td><?php psn(1) ?></td><td><?php psv(1) ?></td></tr>
    <tr><td>2</td><td><?php psn(2) ?></td><td><?php psv(2) ?></td></tr>
    <tr><td>3</td><td><?php psn(3) ?></td><td><?php psv(3) ?></td></tr>
    <tr><td>4</td><td><?php psn(4) ?></td><td><?php psv(4) ?></td></tr>
    <tr><td>5</td><td><?php psn(5) ?></td><td><?php psv(5) ?></td></tr>
    <tr><td>6</td><td><?php psn(6) ?></td><td><?php psv(6) ?></td></tr>
    <tr><td>7</td><td><?php psn(7) ?></td><td><?php psv(7) ?></td></tr>
    <tr><td>8</td><td><?php psn(8) ?></td><td><?php psv(8) ?></td></tr>
    <tr><td>9</td><td><?php psn(9) ?></td><td><?php psv(9) ?></td></tr>
    <tr><td>10</td><td><?php psn(10) ?></td><td><?php psv(10) ?></td></tr>
    <tr><td>11</td><td><?php psn(11) ?></td><td><?php psv(11) ?></td></tr>
    <tr><td>12</td><td><?php psn(12) ?></td><td><?php psv(12) ?></td></tr>
    <tr><td>13</td><td><?php psn(13) ?></td><td><?php psv(13) ?></td></tr>
    <tr><td>14</td><td><?php psn(14) ?></td><td><?php psv(14) ?></td></tr>
    <tr><td>15</td><td><?php psn(15) ?></td><td><?php psv(15) ?></td></tr>
    <tr><td>16</td><td><?php psn(16) ?></td><td><?php psv(16) ?></td></tr>
  </table>
  <table class="t2" style="margin-top:20px; margin-right:30px; float:left">
    <tr><th></th><th>Sensor</th><th>Wert</th></tr>
    <tr><td>17</td><td><?php psn(17) ?></td><td><?php psv(17) ?></td></tr>
    <tr><td>18</td><td><?php psn(18) ?></td><td><?php psv(18) ?></td></tr>
    <tr><td>19</td><td><?php psn(19) ?></td><td><?php psv(19) ?></td></tr>
    <tr><td>20</td><td><?php psn(20) ?></td><td><?php psv(20) ?></td></tr>
    <tr><td>21</td><td><?php psn(21) ?></td><td><?php psv(21) ?></td></tr>
    <tr><td>22</td><td><?php psn(22) ?></td><td><?php psv(22) ?></td></tr>
    <tr><td>23</td><td><?php psn(23) ?></td><td><?php psv(23) ?></td></tr>
    <tr><td>24</td><td><?php psn(24) ?></td><td><?php psv(24) ?></td></tr>
    <tr><td>25</td><td><?php psn(25) ?></td><td><?php psv(25) ?></td></tr>
    <tr><td>26</td><td><?php psn(26) ?></td><td><?php psv(26) ?></td></tr>
    <tr><td>27</td><td><?php psn(27) ?></td><td><?php psv(27) ?></td></tr>
    <tr><td>28</td><td><?php psn(28) ?></td><td><?php psv(28) ?></td></tr>
    <tr><td>29</td><td><?php psn(29) ?></td><td><?php psv(29) ?></td></tr>
    <tr><td>30</td><td><?php psn(30) ?></td><td><?php psv(30) ?></td></tr>
    <tr><td>31</td><td><?php psn(31) ?></td><td><?php psv(31) ?></td></tr>
  </table>
  <table class="t2" style="margin-top:20px">
    <tr><th></th><th>Alarm</th><th>Status</th></tr>
    <tr><td>1</td><td><?php aln(1) ?></td><td><?php alv(1) ?></td></tr>
    <tr><td>2</td><td><?php aln(2) ?></td><td><?php alv(2) ?></td></tr>
    <tr><td>3</td><td><?php aln(3) ?></td><td><?php alv(3) ?></td></tr>
    <tr><td>4</td><td><?php aln(4) ?></td><td><?php alv(4) ?></td></tr>
  </table>
  <table class="t2" style="margin-top:30px">
    <tr><td><?php psm() ?></td></tr>
  </table>
</body>
</html>
